/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* BiDiPro/AVR v0.1.2                                               common.h
* Copyright (c) Oleg O. Chukaev, 2007-2009  <oleg.chukaev@mail.ru>
* Based on AVRPP - AVR Parallel Programming Controller  R0.39 (C)ChaN, 2007
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/


#ifndef AVR_COMMON_H
#define AVR_COMMON_H


//extern byte code_buff[MAX_FLASH];	/* Program code R/W buffer */
extern byte *code_buff;	/* Program code R/W buffer */
extern byte data_buff[MAX_EEPROM];	/* EEPROM data R/W buffer */

extern byte cal_buff[4];		/* Calibration bytes read buffer */
extern byte fuse_buff[3];		/* Fuse bytes read buffer */
extern byte sign_buff[3];		/* Device signature read buffer */
extern byte lock_byte;			/* Lock byte */

extern DEVPROP *dev_list[MAX_DEVICES];	/* ᨢ 㪠⥫  .  */
extern DEVPROP *device;			/* ⥫  ࠬ ⥪饣  */

extern const char *const port_modes[];

extern char *fuse_names[MAX_FUSES];	/* ᨢ 㪠⥫   fuse-⮢ */
extern char *fuse_descr[MAX_FUSES];	/* ᨢ 㪠⥫  ᠭ fuse-⮢ */

int set_device (char *name);
int detect_device (int f_mode, int l_mode, void (*print)(void));
int write_buffer (int dst, char *fname, byte *addr, dword size);
int read_file (int type, char *fname, byte *addr, dword size, dword *datasize);
int read_flash (void (*print)(dword, dword));
int read_eeprom (void (*print)(dword, dword));
void read_fusecal (void);
int write_flash (void (*print)(dword, dword));
int write_eeprom (void (*print)(dword, dword));
int verify_flash (void (*print)(dword, dword), void (*fail)(dword, byte, byte));
int verify_eeprom (void (*print)(dword, dword), void (*fail)(dword, byte, byte));


#endif /* AVR_COMMON_H */

/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* E0F
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/

