/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* BiDiPro/AVR v0.1.2                                              defines.h
* Copyright (c) Oleg O. Chukaev, 2007-2009  <oleg.chukaev@mail.ru>
* Based on AVRPP - AVR Parallel Programming Controller  R0.39 (C)ChaN, 2007
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/


#ifndef AVR_DEFINES_H
#define AVR_DEFINES_H


#ifdef LINUXXX
# define PATH_SEPARATOR '/'
# define strnicmp strncasecmp
# define stricmp strcasecmp
# define farmalloc malloc
# ifndef MAXPATH
#  define MAXPATH 1024
# endif
#else
# define PATH_SEPARATOR '\\'
# define strerror my_strerror
# ifndef MAXPATH
#  define MAXPATH 80
# endif
#endif

#ifndef PROGNAME_LEN
# define PROGNAME_LEN 100
#endif


#ifndef NELEMS
# define NELEMS(array)	(sizeof(array) / sizeof(array[0]))
#endif

#ifndef LINUXXX
char *my_strerror (int errnum);
#endif

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned long dword;

typedef void (*sighandler_t)(int);


/*  / /祭 */
#define	DEVICE_FOUND	0
#define	DEVICE_UNKNOWN	1
#define	DEVICE_LOCKED	2


/* ࠬ dst  read_file() / write_buffer() */
#define IO_HEX_STDOUT	0
#define IO_HEX_FILE	1
#define IO_BIN_FILE	2


/*  . 䠩 */
#define FUSEFILE  "fuses.cfg"
#define CHIPSFILE "chips.cfg"
#define INIFILE   "avrc.cfg"


/* Program return codes */
#define	RC_SUCCESS	0
#define	RC_FAIL		1
#define	RC_INIT_MEM	10
#define	RC_INIT_CFG	11
#define	RC_INIT_HW	12
#define	RC_INIT_DEV	13
#define	RC_SYNTAX	20
#define	RC_READ		30
#define	RC_ERASE	31
#define	RC_WRITE	32
#define	RC_FUSES	33
#define	RC_FILE_RD	40
#define	RC_FILE_HEX	41
#define	RC_FILE_WR	42
#define	RC_INT		50


/* Buffer size for flash/eeprom */
#define	MAX_FLASH	(128*1024L)
/*#define	MAX_FLASH	(32768L)*/
#define	MAX_EEPROM	(  4*1024L)


/* ᨬ쭮 ᫮ ন  */
#define MAX_DEVICES	400


/* ᨬ쭮 - fuse+lock ⮢ */
#define MAX_FUSES	32


#endif /* AVR_DEFINES_H */

/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* E0F
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/
