/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* BiDiPro/AVR v0.1.4                 hwctrl.c -- hardware control functions
* Copyright (c) Oleg O. Chukaev, 2007-2010  <oleg.chukaev@mail.ru>
* Based on AVRPP - AVR Parallel Programming Controller  R0.39 (C)ChaN, 2007
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/


/*-------------------------------------------------------------------------
  砥 䠩
-------------------------------------------------------------------------*/


#ifdef LINUXXX
# include <unistd.h>
#else
# include <dos.h>
#endif

#include "defines.h"
#include "cmds.h"
#include "hwctrl.h"
#include "bidi.h"


/*-------------------------------------------------------------------------
   ६
-------------------------------------------------------------------------*/

int port_number = 1;		/*  ࠫ쭮 : 1..3 */
int port_mode = PAR;		/*  ணࠬ஢: PAR, HVS, HVS15[_OLD] */
int quick_power = 0;		/* 1:  ० 祭 ⠭ */
int vcc = DEFAULT_VCC;		/* 殮 ⠭ ( 100 ) */
int vpp = DEFAULT_VPP;		/* 殮 ணࠬ஢ ( 100 ) */


/*-------------------------------------------------------------------------
   ६
-------------------------------------------------------------------------*/

static byte reg_dat;
static byte sci_bit = SCI_BIT;	/*  HVS  SCI: SCI_BIT  SCI_T15_BIT */
static int port_initialized = 0;


/*-------------------------------------------------------------------------
   㭪樨
-------------------------------------------------------------------------*/

/****************************************************************************
* 樠 ணࠬ.
* ࠬ:
*	ᯮ ६ port_mode, port_number, vcc, vpp.
* 頥:
*	 訡: 0x0000 -- Ok, 0x01?? -- 訡, ?? -- . ࠩ.
****************************************************************************/

int initialize_port (void) {

	int rc;
	const word port_list[] = {LPT1ADR, LPT2ADR, LPT3ADR};

	if (port_number < 4) {
		portaddr = port_list[port_number-1];
	} else {
		portaddr = port_number;
	}
	rc = init ();
	voltage (vcc, vpp, 140);
	port_initialized = 1;
	return (rc);
}


/****************************************************************************
* 蠥 ࠡ ணࠬ. ( ⮫쪮 㯮 몫砥 ⠭ .)
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void close_port (void) {

	if (port_initialized) {
		port_initialized = 0;
		power_off ();
	}
}


/****************************************************************************
*  প.
* ࠬ:
*	dly -- প  .
* 頥:
*	---
****************************************************************************/

/* !!!  ??? */

void delay_ms (word dly) {

#ifdef LINUXXX
	usleep (dly*1000);
#else
	delay (dly);
#endif
}


/****************************************************************************
* 砥 ⠭ , ॢ   ० ணࠬ஢.
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void power_on (void) {

	int n;

	bdport (PFORCE | PWR1 | PCIN);
	bdport (PFORCE | PWR2);
	voltage (vcc, vpp, 140);

	switch (port_mode) {
	case PAR:
		/*
		** For parallel devices
		*/
		bdport (PWB2 | VCC_BIT);	/* Vcc on */
		if (!quick_power) {
			delay_ms (1);
			/* Toggle XTAL1 six times */
			for (n = 0; n < 6; n++) {
				bdport (PWA1 | B_XT1);
				bdport (PWA1 | 0);
			}
		}
		reg_dat = B_OE;
		bdport (PWA1 | reg_dat);		/* OE = H */
		bdport (PWA2 | BITPE);			/* Enable Vpp */
		bdport (PWB2 | VCC_BIT | VPP_BIT);	/* Vpp on */
		reg_dat |= B_WR;
		bdport (PWA1 | reg_dat);		/* WR = H */
		delay_ms (1);				/* 1ms */
		break;

	case HVS:
	case HVS15:
	case HVS15_OLD:
		/*
		** For 8 and 14 pin devices
		*/

		if (port_mode == HVS15) {
			sci_bit = SCI_T15_BIT;
		} else {
			sci_bit = SCI_BIT;
		}
		/* Set Prog_enable state to "000" */
		bdport (WRITE_SDO | SDO_BIT);
		delay_ms (1);		/* 1ms */
		if (quick_power) {
			/* Quick power-up */
			bdport (PWA2 | BITPE);		/* Vcc+Vpp on */
			bdport (PWB2 | VPP_BIT | VCC_BIT);
		} else {
			/* Normal power-up */
			bdport (PWB2 | VCC_BIT);	/* Vcc on */
			delay_ms (1);
			/* Toggle CLK six times */
			for (n = 0; n < 6; n++) {
				bdport (WRITE_ANY | sci_bit); delay_ms (1);
				bdport (WRITE_ANY); delay_ms (1);
			}
			bdport (PWA2 | BITPE);		/* Vpp on */
			bdport (PWB2 | VPP_BIT | VCC_BIT);
		}
		bdport (PWR1 | IN_PORT);
		delay_ms (1);		/* 1ms */
		break;

	case ISP:
		/*
		** ISP mode
		*/
		bdport (PWB2 | VCC_BIT);	/* Vcc on,  ⮫쪮  */
		enter_ispmode ();		/* 祭 ० ணࠬ஢ */
		break;
	}
}


/****************************************************************************
* 몫砥 ⠭ , 뢮   ० ணࠬ஢.
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void power_off (void) {

	switch (port_mode) {
	case PAR:
	case HVS:
	case HVS15:
	case HVS15_OLD:
		/*
		** For parallel devices
		** 1. -RESET <- 1
		** 2. Vcc <- 0
		**
		** For 8 and 14 pin devices
		** 1. SCI <- 0
		** 2. -RESET <- 1
		** 3. Vcc <- 0
		*/
		bdport (PWA2);			/* Vpp off */
		bdport (PWB2 | VCC_BIT);	/* Vcc  ⠢ */
		delay_ms (1);			/* 1ms */
		bdport (WRITE_ANY);		/* Signals = L */
		bdport (PWB2);			/* Vcc off */
		delay_ms (10);			/* 10ms */
		break;

	case ISP:
		/*
		** ISP mode
		** 1. -RESET <- 1
		** 2. Vcc <- 0  (       ...)
		*/
		bdport (WRITE_ANY | RESET_BIT);	/* -RESET <- 1 */
		bdport (PWB2);			/* Vcc off */
		delay_ms (10);			/* 10ms */
		break;
	}
}


/****************************************************************************
*  襭 ⥪饩 ७ 樨  (.. 1  SDO).
* ࠬ:
*	---
* 頥:
*	0 -- ᯥ譮 襭
*	1 -- ⠩
****************************************************************************/

int wait_ready () {

	long n = 50000L;

	bdport (READ_SDO);
	/*   窨  SDO */
	while ((n > 0) && ((bdport (READ_SDO) & SDO_BIT) == 0))
		n--;

	return (n ? 0 : 1);
}


/*-------------------------------------------------------------------------
  ࠫ ०
-------------------------------------------------------------------------*/

/****************************************************************************
* 㦠 //.
* ࠬ:
*	mode -- 祭 ᨣ XA0, XA1, BS1, BS2: XA_0, XA_1, BS_1, BS_2.
*	dat  -- //.
* 頥:
*	---
****************************************************************************/

void set_byte (byte mode, byte dat) {

	/* -OE  -WR  1 */
	reg_dat = B_OE | B_WR;

	/* Setup XA[1:0], BS[2:1] */
	if (mode & XA_0)
		reg_dat |= B_XA0;
	if (mode & XA_1)
		reg_dat |= B_XA1;
	if (mode & BS_1)
		reg_dat |= B_BS1;
	if (mode & BS_2)
		reg_dat |= B_BS2;

	bdport (PWA1 | reg_dat);

	/* ⠢   設 */
	bdport (PWB1 | dat);

	/* Give XTAL1 pulse */
	bdport (PWA1 | reg_dat | B_XT1);
	bdport (PWA1 | reg_dat);

	/* BS2 = L */
	reg_dat &= (byte)~B_BS2;
	bdport (PWA1 | reg_dat);
}


/****************************************************************************
* ⥭   .
* ࠬ:
*	mode -- 祭 ᨣ XA0, XA1, BS1, BS2: XA_0, XA_1, BS_1, BS_2.
* 頥:
*	⠭ .
****************************************************************************/

byte rcv_byte (byte mode) {

	byte dat = 0;

	reg_dat = B_OE | B_WR;

	/* Setup XA[1:0], BS[2:1] */
	if (mode & XA_0)
		reg_dat |= B_XA0;
	if (mode & XA_1)
		reg_dat |= B_XA1;
	if (mode & BS_1)
		reg_dat |= B_BS1;
	if (mode & BS_2)
		reg_dat |= B_BS2;

	bdport (PWR1 | PBIN | PCIN);	/* OII */
	bdport (PWA1 | reg_dat);

	reg_dat &= (byte)~B_OE;		/* OE = 0 */
	bdport (PWA1 | reg_dat);

	dat = bdport (PRB1) & 0xff;

	reg_dat |= B_OE;		/* OE = 1 */
	bdport (PWA1 | reg_dat);

	bdport (PWR1 | PCIN);		/* OOI */
	bdport (PWA1 | reg_dat);

	return (dat);
}


/****************************************************************************
*  ⥫   뢮 PAGEL.
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void stb_pagel (void) {

	bdport (PWA1 | reg_dat | B_PAGEL);
	bdport (PWA1 | reg_dat);
}



/****************************************************************************
*  ⥫  ।񭭮 ⥫쭮  뢮 WR-.
* ࠬ:
*	mode -- 祭 ᨣ XA0, XA1, BS1, BS2: XA_0, XA_1, BS_1, BS_2.
*	dly  -- ਭ  ( .)
* 頥:
*	---
****************************************************************************/

void stb_wr (byte mode, word dly) {

	reg_dat = B_OE | B_WR;

	/* Setup XA[1:0], BS[2:1] */
	if (mode & XA_0)
		reg_dat |= B_XA0;
	if (mode & XA_1)
		reg_dat |= B_XA1;
	if (mode & BS_1)
		reg_dat |= B_BS1;
	if (mode & BS_2)
		reg_dat |= B_BS2;

	bdport (PWA1 | reg_dat);

	reg_dat &= (byte)~B_WR;
	bdport (PWA1 | reg_dat);		/* WR = L */
	delay_ms (dly);				/* delay */
	reg_dat |= B_WR;
	bdport (PWA1 | reg_dat);		/* WR = H */
}


/*-------------------------------------------------------------------------
  HVS
-------------------------------------------------------------------------*/

/****************************************************************************
* 뫠   , ⠥   .
* ࠬ:
*	cmd -- .
*	dat -- .
* 頥:
*	⠭ .
****************************************************************************/

byte xfer8 (byte cmd, byte dat) {

	int n, m;

	reg_dat = 0;
	for (n = 0; n < 8; n++) {
		/* Apply 16 SCLKs for tn15 mode, */
		for (m = 0; m < 16; m++) {
			bdport (WRITE_ANY | reg_dat | sci_bit);
			/* But only a rise edge for others */
			if (port_mode != HVS15 && port_mode != HVS15_OLD)
				break;
			bdport (WRITE_ANY | reg_dat);
		}

		/* SCLK=L and Set next data and instruction */
		reg_dat = 0;
		if (dat & 0x80)
			reg_dat |= SDI_BIT;
		if (cmd & 0x80)
			reg_dat |= SII_BIT;

		bdport (WRITE_ANY | reg_dat);
		cmd <<= 1; dat <<= 1;

		/* Read SDO */
		if (bdport (READ_SDO) & SDO_BIT)
			dat++;
	}

	/* Push-in trailing 3 bits... */
	for (n = 0; n < 3; n++) {
		for (m = 0; m < 16; m++) {
			bdport (WRITE_ANY | reg_dat | sci_bit);
			if (port_mode != HVS15 && port_mode != HVS15_OLD)
				break;
			bdport (WRITE_ANY | reg_dat);
		}
		/* send 0 */
		bdport (WRITE_ANY);
	}

	return (dat);
}


/*-------------------------------------------------------------------------
  ISP
-------------------------------------------------------------------------*/

/****************************************************************************
* ॢ   ० ISP.
* ࠬ:
*	---
* 頥:
*	0 -- ᯥ 室  ISP
*	1 -- 訡
****************************************************************************/

int enter_ispmode (void) {

	byte rd;
	int tried, scan;

	spi_reset ();	/* Reset device */
	for (tried = 1; tried <= 3; tried++) {
		for (scan = 1; scan <= 64; scan++) {
			spi_xmit (ISP_C_EN_PRG1);	/* 1st cmd */
			spi_xmit (ISP_C_EN_PRG2);	/* 2nd cmd */
			rd = spi_rcvr ();		/* 3rd cmd and read echo back */
			spi_xmit (0);			/* 4th cmd */
			if (rd == ISP_C_EN_PRG2)
				return (0);		/* Was 2nd command echoed back? */
			if (tried <= 2)
				break;			/* first 2 attempts are for 1200, final attempt is for others */
			spi_clk ();			/* shift scan point */
		}
	}
	return (1);
}


/****************************************************************************
* ⢫  .
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void spi_reset (void) {

	bdport (WRITE_ANY | RESET_BIT);
	delay_ms (1);			/* !!! 㬥 ??? */
	bdport (WRITE_ANY);
	delay_ms (30);			/* 30msec */
}


/****************************************************************************
*  ⥫   SCK.
* ࠬ:
*	---
* 頥:
*	---
****************************************************************************/

void spi_clk (void) {

	delay_us (5);
	bdport (WRITE_ANY | SCK_BIT);
	delay_us (5);
	bdport (WRITE_ANY);
}


/****************************************************************************
* 뫠   .
* ࠬ:
*	td -- 
* 頥:
*	---
****************************************************************************/

void spi_xmit (byte td) {

	byte a;
	int i;

	for (i = 0; i < 8; i++) {
		a = ((td & 0x80) ? MOSI_BIT : 0);	/* MOSI = data, SCK = "L" */
		bdport (WRITE_ANY | a);
		delay_us (5);
		bdport (WRITE_ANY | a | SCK_BIT);	/* SCK = "H" */
		delay_us (5);
		td <<= 1;
	}
	bdport (WRITE_ANY | a);
}


/****************************************************************************
* 뫠   㫥   ⠥   .
* ࠬ:
*	---
* 頥:
*	⠭ 
****************************************************************************/

byte spi_rcvr (void) {

	byte rd = 0;
	int i;

	bdport (WRITE_ANY);				/* MOSI = "L" */
	delay_us (5);
	for (i = 0; i < 8; i++) {
		rd <<= 1;				/* Read MISO */
		if (bdport (READ_MISO) & MISO_BIT)
			rd++;
		bdport (WRITE_ANY | SCK_BIT);		/* SCK = "H" */
		delay_us (5);
		bdport (WRITE_ANY);			/* SCK = "L" */
		delay_us (5);
	}

	return (rd);
}


/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* E0F
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/

