/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* BiDiPro/AVR v0.1.4               hwctrl.h -- hardware control definitions
* Copyright (c) Oleg O. Chukaev, 2007-2010  <oleg.chukaev@mail.ru>
* Based on AVRPP - AVR Parallel Programming Controller  R0.39 (C)ChaN, 2007
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/


#ifndef AVR_HWCTRL_H
#define AVR_HWCTRL_H


/* Port number and port address */
#define	LPT1ADR		0x0378
#define	LPT2ADR		0x0278
#define	LPT3ADR		0x03BC


/*  祭 ६ port_mode. ।,  */
/* PAR -- 쭮 祭,  ISP -- ᨬ쭮. */
#define PAR		0
#define HVS		1
#define HVS15		2
#define HVS15_OLD	3
#define ISP		4


/* XA/BS identifier for read/write commands */
#define XA_0		0x01
#define	XA_1		0x02
#define	BS_1		0x04
#define BS_2		0x08


/*  1- 55, ࠡ騩  , ⠭  r/w  ० HVS/ISP */
#define IN_PORT		PCIN
#define READ_SDO	PRC1
#define READ_MISO	PRC1
#define WRITE_SDO	PWC1
#define WRITE_ANY	PWA1


/* ᪨ ࠧ ⮢  ० HVS */
#define SDO_BIT		0x01
#define SCI_BIT		0x01
#define SDI_BIT		0x02
#define SII_BIT		0x04
#define SCI_T15_BIT	0x08


/* ᪨ ࠧ ⮢  ० ISP */
#define MISO_BIT	0x01
#define SCK_BIT		0x01
#define MOSI_BIT	0x02
#define RESET_BIT	0x04


/*  殮 ⠭  ணࠬ஢ */
#define VCC_BIT		BITVCC32
#define VPP_BIT		BITVPP28
#define VPP_1_BIT	BITOE


/* ᪨ ⮢ ࠢ ࠫ ணࠬ஢ */
#define B_XT1		0x01
#define B_OE		0x02
#define B_WR		0x04
#define B_BS1		0x08
#define B_XA0		0x10
#define B_XA1		0x20
#define	B_BS2		0x40
#define	B_PAGEL		0x80


/* 殮  㬮砭 */
#define DEFAULT_VCC	45
#define DEFAULT_VPP	120



/* *** 㭪樨 *** */

/* 騥 */
int initialize_port (void);
void close_port (void);
void power_on (void);
void power_off (void);
void delay_ms (word);
int wait_ready (void);

/* Parallel */
void set_byte (byte, byte);
byte rcv_byte (byte);
void stb_pagel (void);
void stb_wr (byte, word);

/* HVS */
byte xfer8 (byte, byte);

/* ISP */
void spi_reset (void);
void spi_clk (void);
void spi_xmit (byte);
byte spi_rcvr (void);
int enter_ispmode (void);


/* ६ */
extern int port_number;	/*  ࠫ쭮 : 1..3 */
extern int port_mode;	/*  ணࠬ஢: PAR, HVS, HVS15[_OLD] */
extern int quick_power;	/* 1:  ० 祭 ⠭ */
extern int vcc;		/* 殮 ⠭,  100  */
extern int vpp;		/* 殮 ணࠬ஢,  100  */


#endif /* AVR_HWCTRL_H */

/** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* E0F
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/
